#include "../common/const.h"
#include "../common/global.h"
#include "../common/types.h"
#include "send.h"
#include <iostream>
#include <wolfssl/options.h>
#include <wolfssl/ssl.h>
#include <wolfssl/wolfcrypt/types.h>

Timer<WOLFSSL *> keep_alive_timer;

void send_keep_alive(WOLFSSL *ssl) {}

void listen_for_incoming_packets(WOLFSSL *ssl) {
  unsigned char buf[IP_PACKET_BUFFER_SIZE];
  keep_alive_timer.arm(
      180000, 0, [](WOLFSSL *ssl) { send_keep_alive(ssl); }, ssl);

  while (true) {
    int bytes = wolfSSL_read(ssl, buf, sizeof(buf) - 1);
    if (bytes > 0) {
      switch (buf[0]) {
      case KEEP_ALIVE_TYPE: {
        unsigned char response = KEEPING_ALIVE_TYPE;
        wolfSSL_write(ssl, &response, sizeof(response));
        std::clog << "Received keep-alive message, sent response." << std::endl;
        keep_alive_timer.reset();
        break;
      }
      case IP_PACKET_TYPE: {
        send_IP_packet(buf + 1, bytes - 1);
        break;
      }
      case TERMINATE_CONNECTION_TYPE: {
        std::cout << "Received terminate connection request." << std::endl;
        return;
      }
      }
    } else if (bytes == 0) {
      std::cout << "Connection closed by peer" << std::endl;
      break;
    } else {
      int ssl_error = wolfSSL_get_error(ssl, bytes);
      std::cerr << "wolfSSL_read failed with error: " << ssl_error << std::endl;
      break;
    }
  }
}